unit ModSet;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  XComDrv, Menus, StdCtrls, ExtCtrls, ClipBrd;

type
  TFMod = class(TForm)
    gbCon             : TGroupBox;
    rbDial            : TRadioButton;
    rbWait            : TRadioButton;
    rbDirect          : TRadioButton;
    gbStr             : TGroupBox;
    L1                : TLabel;
    L2                : TLabel;
    LN                : TLabel;
    eInit             : TEdit;
    eRes              : TEdit;
    eNum              : TEdit;
    B1                : TBevel;
    B2                : TBevel;
    B3                : TBevel;
    gbOpt             : TGroupBox;
    rbPulse           : TRadioButton;
    rbTone            : TRadioButton;
    BOK               : TButton;
    BCancel           : TButton;
    procedure FormShow(Sender: TObject);
    procedure rbWaitClick(Sender: TObject);
    procedure rbDialClick(Sender: TObject);
    procedure rbDirectClick(Sender: TObject);
    procedure BOKClick(Sender: TObject);
    procedure BCancelClick(Sender: TObject);
    procedure eNumKeyPress(Sender: TObject; var Key: Char);
    procedure eNumKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    SNumber, SRings: string;
  public
    { Public declarations }
    procedure ApplySettings;
    procedure CancelSettings;    
  end;

var
  FMod: TFMod;

implementation

uses Main;

{$R *.DFM}

procedure TFMod.FormShow(Sender: TObject);
begin
  CancelSettings;
end;

procedure TFMod.rbWaitClick(Sender: TObject);
begin
  if gbOpt.Visible and rbTone.Visible
    then SNumber := eNum.Text;
  gbOpt.Visible := True;
  LN.Caption := 'Rings:';
  eNum.Text := SRings;
  rbTone.Visible := False;
  rbPulse.visible := False;
end;

procedure TFMod.rbDialClick(Sender: TObject);
begin
  if gbOpt.Visible and not rbTone.Visible
    then SRings := eNum.Text;
  gbOpt.Visible := True;
  LN.Caption := 'Number:';
  eNum.Text := SNumber;
  rbTone.Visible := True;
  rbPulse.visible := True;
end;

procedure TFMod.rbDirectClick(Sender: TObject);
begin
  if rbTone.Visible then
    SNumber := eNum.Text
  else if gbOpt.Visible then
    SRings := eNum.Text;
  gbOpt.Visible := False;
end;

procedure TFMod.ApplySettings;
begin
  with FMain, Modem.ModemSettings do
  begin
    InitString := eInit.Text;
    ResetString := eRes.Text;
    if rbDial.Checked then
    begin
      ConnectType := ctDial;
      SNumber := eNum.Text;
    end
    else if rbWait.Checked then
    begin
      ConnectType := ctWait;
      SRings := eNum.Text;
    end
    else ConnectType := ctDirect;
    if rbTone.Checked
      then DialType := dtTone
      else DialType := dtPulse;
    DialNumber := SNumber;
    if (SRings='')
      then WaitRings := 0
      else WaitRings := StrToInt(SRings);
  end;
end;

procedure TFMod.CancelSettings;
begin
  with FMain.Modem.ModemSettings do
  begin
    if rbDial.Checked then
      eNum.Text := DialNumber
    else if rbWait.Checked then
      eNum.Text := IntToStr(WaitRings);
    eInit.Text := InitString;
    eRes.Text := ResetString;
    SNumber := DialNumber;
    SRings := IntToStr(WaitRings);
    case ConnectType of
      ctDial: rbDial.Checked := True;
      ctWait: rbWait.Checked := True;
      ctDirect: rbDirect.Checked := True;
    end;
    if DialType = dtTone
      then rbTone.Checked := True
      else rbPulse.Checked := True;
  end;
end;

procedure TFMod.BOKClick(Sender: TObject);
begin
  ApplySettings;
end;

procedure TFMod.BCancelClick(Sender: TObject);
begin
  CancelSettings;
end;

procedure TFMod.eNumKeyPress(Sender: TObject; var Key: Char);
var s: string;
begin
  if not (Key in [#8, '0'..'9']) then Key := #0;
  if rbWait.Checked and (Key<>#0) and (Key<>#8) then
  begin
    s := eNum.Text+Key;
    if (StrToInt(s)>255) then Key:=#0;
  end;
end;

procedure TFMod.eNumKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  s: string;
  i: Integer;
begin
  if (Shift = [ssCtrl]) and (Key=86) then
  try
    Key := 0;
    s := Clipboard.AsText;
    Caption := s;
    if (s<>'') then
    begin
      i := 1;
      while (i<=Length(s)) do
        if (s[i] in ['0'..'9'])
          then Inc(i)
          else Delete(s, i, 1);
      eNum.SelText := s;
      s := eNum.Text;
      if rbWait.Checked and (StrToInt(s)>255) then
      begin
        i := eNum.SelStart;
        while (StrToInt(s)>255) do Delete(s, Length(s), 1);
        eNum.Text := s;
        eNum.SelStart := i;
      end;
    end;
  except
    on EConvertError do eNum.Text := '';  
  end;
end;


end.
